local toc, data = ...
local AddonId = toc.identifier

local statList = Inspect.Stat()
local mouseFrame = {}
local mouseFrameCreated = false
local toNum = tonumber

GS = {}
GS.Context = UI.CreateContext("gsContext")
GS.Context:SetStrata("modal")
GS.display = {}

local function mouseUpdate(xcoord, ycoord)
	
	local function createMouseFrame()
		mouseFrame = UI.CreateFrame("Frame", "mouseFrame", GS.Context)
			mouseFrame:SetHeight(22)
			mouseFrame:SetWidth(143)
			mouseFrame:SetBackgroundColor(1,1,1,1)
			mouseFrame:SetLayer(10)
			mouseFrame:SetVisible(false)
			
		mouseFrame.icon = UI.CreateFrame("Texture", "mouseFrame_icon", mouseFrame)
			mouseFrame.icon:SetPoint("CENTERLEFT", mouseFrame, "CENTERLEFT", 1, 0)
			mouseFrame.icon:SetBackgroundColor(0,0,0,1)
			mouseFrame.icon:SetHeight(20)
			mouseFrame.icon:SetWidth(20)
			mouseFrame.icon:SetLayer(20)
		
		mouseFrame.text = UI.CreateFrame("Text", AddonId .. "mouseFrame_text", mouseFrame)
			mouseFrame.text:SetPoint("CENTERLEFT", mouseFrame.icon, "CENTERRIGHT")
			mouseFrame.text:SetHeight(20)
			mouseFrame.text:SetWidth(121)
			mouseFrame.text:SetBackgroundColor(0,0,0,1)
			mouseFrame.text:SetFontColor(1,1,1,1)
			mouseFrame.text:SetFontSize(14)
			mouseFrame.text:SetLayer(20)
			
		mouseFrameCreated = true
	end
	
	if mouseFrameCreated == false then
		createMouseFrame()
	end
	
	if mouseFrame:GetVisible() then
		mouseFrame:SetPoint("CENTER", WT.Context, "CENTER", xcoord-18, ycoord-18)
	end
	
end

local function statUpdate(stats)

	if not GS.display then return end

	for id, columns in pairs(GS.display) do
		for name, num in pairs(stats) do
			for column, rows in ipairs(GS.display[id].data) do
				for row, data in pairs(rows) do
					if name == data.name then
						data.stat:SetText(tostring(num))
					end
				end
			end
		end
	end
end

function GS:PreviewCellConfig(cellInfo)

	local checkbox

	if not GS.cellConfig then
	
	Command.System.Watchdog.Quiet()
		
		GS.cellConfig = UI.CreateFrame("Texture", AddonId .. "_cellConfig", GS.container)
			GS.cellConfig:SetPoint("CENTERLEFT", GS.container, "CENTERRIGHT", 10, -40)
			GS.cellConfig:SetHeight(450)
			GS.cellConfig:SetWidth(300)
			GS.cellConfig:SetTexture(AddonId, "img/midWindow.png")
			
		GS.cellConfig.btnOK = UI.CreateFrame("RiftButton", AddonId .. "_cellConfig_OKbtn", GS.cellConfig)
			GS.cellConfig.btnOK:SetText("OK")
			GS.cellConfig.btnOK:SetPoint("BOTTOMRIGHT", GS.cellConfig, "BOTTOMCENTER", 0, -10)
			GS.cellConfig.btnOK:SetEnabled(true)
			
		GS.cellConfig.btnCancel = UI.CreateFrame("RiftButton", AddonId .. "_cellConfig_Cancelbtn", GS.cellConfig)
			GS.cellConfig.btnCancel:SetText("CANCEL")
			GS.cellConfig.btnCancel:SetPoint("BOTTOMLEFT", GS.cellConfig, "BOTTOMCENTER", 0, -10)
			GS.cellConfig.btnCancel:SetEnabled(true)
			GS.cellConfig.btnCancel.Event.LeftPress = function()
				GS.cellConfig:SetVisible(false)
			end
			
		GS.cellConfig.bg = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg", GS.cellConfig)
			GS.cellConfig.bg:SetPoint("TOPLEFT", GS.cellConfig, "TOPLEFT", 20, 25)
			GS.cellConfig.bg:SetFontColor(1,1,1,1)
			GS.cellConfig.bg:SetFontSize(14)
			GS.cellConfig.bg:SetText("Background Color                 Cell: " .. cellInfo.row .. ", " .. cellInfo.column)
			
			GS.cellConfig.bg.preview = UI.CreateFrame("Frame", AddonId .. "_cellConfig_bg_preview", GS.cellConfig.bg)
				GS.cellConfig.bg.preview:SetPoint("TOPLEFT", GS.cellConfig.bg, "BOTTOMLEFT", 0, 5)
				GS.cellConfig.bg.preview:SetHeight(60)
				GS.cellConfig.bg.preview:SetWidth(45)
				GS.cellConfig.bg.preview:SetBackgroundColor(0,0,0,1)
			
			GS.cellConfig.bg.red = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg_red", GS.cellConfig.bg)
				GS.cellConfig.bg.red:SetPoint("TOPLEFT", GS.cellConfig.bg.preview, "TOPRIGHT", 22, 0)
				GS.cellConfig.bg.red:SetFontColor(1,1,1,1)
				GS.cellConfig.bg.red:SetFontSize(12)
				GS.cellConfig.bg.red:SetText("Red")
			
			GS.cellConfig.bg.red.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_bg_red_slider", GS.cellConfig.bg.red)
				GS.cellConfig.bg.red.slider:SetPoint("CENTERLEFT", GS.cellConfig.bg.red, "CENTERRIGHT", 12, 6)
				GS.cellConfig.bg.red.slider:SetRange(0,255)
				GS.cellConfig.bg.red.slider:SetWidth(120)
				GS.cellConfig.bg.red.slider:SetPosition(0)
				GS.cellConfig.bg.red.slider.Event.SliderChange = function()
					GS.cellConfig.bg.red.value:SetText(tostring(GS.cellConfig.bg.red.slider:GetPosition()))
					GS.cellConfig.bg.preview:SetBackgroundColor(GS.cellConfig.bg.red.slider:GetPosition()/255,GS.cellConfig.bg.green.slider:GetPosition()/255,GS.cellConfig.bg.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.bg.red.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg_red_value", GS.cellConfig.bg.red)
				GS.cellConfig.bg.red.value:SetPoint("CENTERLEFT", GS.cellConfig.bg.red.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.bg.red.value:SetFontColor(1,1,1,1)
				GS.cellConfig.bg.red.value:SetFontSize(12)
				GS.cellConfig.bg.red.value:SetText(tostring(GS.cellConfig.bg.red.slider:GetPosition()))
			
			GS.cellConfig.bg.green = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg_green", GS.cellConfig.bg)
				GS.cellConfig.bg.green:SetPoint("CENTERLEFT", GS.cellConfig.bg.preview, "CENTERRIGHT", 10, 0)
				GS.cellConfig.bg.green:SetFontColor(1,1,1,1)
				GS.cellConfig.bg.green:SetFontSize(12)
				GS.cellConfig.bg.green:SetText("Green")
			
			GS.cellConfig.bg.green.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_bg_green_slider", GS.cellConfig.bg.green)
				GS.cellConfig.bg.green.slider:SetPoint("CENTERLEFT", GS.cellConfig.bg.green, "CENTERRIGHT", 12, 6)
				GS.cellConfig.bg.green.slider:SetRange(0,255)
				GS.cellConfig.bg.green.slider:SetWidth(120)
				GS.cellConfig.bg.green.slider:SetPosition(0)
				GS.cellConfig.bg.green.slider.Event.SliderChange = function()
					GS.cellConfig.bg.green.value:SetText(tostring(GS.cellConfig.bg.green.slider:GetPosition()))
					GS.cellConfig.bg.preview:SetBackgroundColor(GS.cellConfig.bg.red.slider:GetPosition()/255,GS.cellConfig.bg.green.slider:GetPosition()/255,GS.cellConfig.bg.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.bg.green.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg_green_value", GS.cellConfig.bg.green)
				GS.cellConfig.bg.green.value:SetPoint("CENTERLEFT", GS.cellConfig.bg.green.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.bg.green.value:SetFontColor(1,1,1,1)
				GS.cellConfig.bg.green.value:SetFontSize(12)
				GS.cellConfig.bg.green.value:SetText(tostring(GS.cellConfig.bg.green.slider:GetPosition()))
			
			GS.cellConfig.bg.blue = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg_blue", GS.cellConfig.bg)
				GS.cellConfig.bg.blue:SetPoint("BOTTOMLEFT", GS.cellConfig.bg.preview, "BOTTOMRIGHT", 19, 0)
				GS.cellConfig.bg.blue:SetFontColor(1,1,1,1)
				GS.cellConfig.bg.blue:SetFontSize(12)
				GS.cellConfig.bg.blue:SetText("Blue")
			
			GS.cellConfig.bg.blue.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_bg_blue_slider", GS.cellConfig.bg.blue)
				GS.cellConfig.bg.blue.slider:SetPoint("CENTERLEFT", GS.cellConfig.bg.blue, "CENTERRIGHT", 12, 6)
				GS.cellConfig.bg.blue.slider:SetRange(0,255)
				GS.cellConfig.bg.blue.slider:SetWidth(120)
				GS.cellConfig.bg.blue.slider:SetPosition(0)
				GS.cellConfig.bg.blue.slider.Event.SliderChange = function()
					GS.cellConfig.bg.blue.value:SetText(tostring(GS.cellConfig.bg.blue.slider:GetPosition()))
					GS.cellConfig.bg.preview:SetBackgroundColor(GS.cellConfig.bg.red.slider:GetPosition()/255,GS.cellConfig.bg.green.slider:GetPosition()/255,GS.cellConfig.bg.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.bg.blue.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_bg_blue_value", GS.cellConfig.bg.blue)
				GS.cellConfig.bg.blue.value:SetPoint("CENTERLEFT", GS.cellConfig.bg.blue.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.bg.blue.value:SetFontColor(1,1,1,1)
				GS.cellConfig.bg.blue.value:SetFontSize(12)
				GS.cellConfig.bg.blue.value:SetText(tostring(GS.cellConfig.bg.blue.slider:GetPosition()))
			
		GS.cellConfig.label = UI.CreateFrame("Text", AddonId .. "_cellConfig_label", GS.cellConfig)
			GS.cellConfig.label:SetPoint("TOPLEFT", GS.cellConfig.bg, "TOPLEFT", 0, 100)
			GS.cellConfig.label:SetFontColor(1,1,1,1)
			GS.cellConfig.label:SetFontSize(14)
			GS.cellConfig.label:SetText("Label Color")
			
			GS.cellConfig.label.preview = UI.CreateFrame("Frame", AddonId .. "_cellConfig_label_preview", GS.cellConfig.label)
				GS.cellConfig.label.preview:SetPoint("TOPLEFT", GS.cellConfig.label, "BOTTOMLEFT", 0, 5)
				GS.cellConfig.label.preview:SetHeight(60)
				GS.cellConfig.label.preview:SetWidth(45)
				GS.cellConfig.label.preview:SetBackgroundColor(1,1,1,1)
			
			GS.cellConfig.label.red = UI.CreateFrame("Text", AddonId .. "_cellConfig_label_red", GS.cellConfig.label)
				GS.cellConfig.label.red:SetPoint("TOPLEFT", GS.cellConfig.label.preview, "TOPRIGHT", 22, 0)
				GS.cellConfig.label.red:SetFontColor(1,1,1,1)
				GS.cellConfig.label.red:SetFontSize(12)
				GS.cellConfig.label.red:SetText("Red")
			
			GS.cellConfig.label.red.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_label_red_slider", GS.cellConfig.label.red)
				GS.cellConfig.label.red.slider:SetPoint("CENTERLEFT", GS.cellConfig.label.red, "CENTERRIGHT", 12, 6)
				GS.cellConfig.label.red.slider:SetRange(0,255)
				GS.cellConfig.label.red.slider:SetWidth(120)
				GS.cellConfig.label.red.slider:SetPosition(255)
				GS.cellConfig.label.red.slider.Event.SliderChange = function()
					GS.cellConfig.label.red.value:SetText(tostring(GS.cellConfig.label.red.slider:GetPosition()))
					GS.cellConfig.label.preview:SetBackgroundColor(GS.cellConfig.label.red.slider:GetPosition()/255,GS.cellConfig.label.green.slider:GetPosition()/255,GS.cellConfig.label.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.label.red.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_label_red_value", GS.cellConfig.label.red)
				GS.cellConfig.label.red.value:SetPoint("CENTERLEFT", GS.cellConfig.label.red.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.label.red.value:SetFontColor(1,1,1,1)
				GS.cellConfig.label.red.value:SetFontSize(12)
				GS.cellConfig.label.red.value:SetText(tostring(GS.cellConfig.label.red.slider:GetPosition()))
			
			GS.cellConfig.label.green = UI.CreateFrame("Text", AddonId .. "_cellConfig_label_green", GS.cellConfig.label)
				GS.cellConfig.label.green:SetPoint("CENTERLEFT", GS.cellConfig.label.preview, "CENTERRIGHT", 10, 0)
				GS.cellConfig.label.green:SetFontColor(1,1,1,1)
				GS.cellConfig.label.green:SetFontSize(12)
				GS.cellConfig.label.green:SetText("Green")
			
			GS.cellConfig.label.green.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_label_green_slider", GS.cellConfig.label.green)
				GS.cellConfig.label.green.slider:SetPoint("CENTERLEFT", GS.cellConfig.label.green, "CENTERRIGHT", 12, 6)
				GS.cellConfig.label.green.slider:SetRange(0,255)
				GS.cellConfig.label.green.slider:SetWidth(120)
				GS.cellConfig.label.green.slider:SetPosition(255)
				GS.cellConfig.label.green.slider.Event.SliderChange = function()
					GS.cellConfig.label.green.value:SetText(tostring(GS.cellConfig.label.green.slider:GetPosition()))
					GS.cellConfig.label.preview:SetBackgroundColor(GS.cellConfig.label.red.slider:GetPosition()/255,GS.cellConfig.label.green.slider:GetPosition()/255,GS.cellConfig.label.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.label.green.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_label_green_value", GS.cellConfig.label.green)
				GS.cellConfig.label.green.value:SetPoint("CENTERLEFT", GS.cellConfig.label.green.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.label.green.value:SetFontColor(1,1,1,1)
				GS.cellConfig.label.green.value:SetFontSize(12)
				GS.cellConfig.label.green.value:SetText(tostring(GS.cellConfig.label.green.slider:GetPosition()))
			
			GS.cellConfig.label.blue = UI.CreateFrame("Text", AddonId .. "_cellConfig_label_blue", GS.cellConfig.label)
				GS.cellConfig.label.blue:SetPoint("BOTTOMLEFT", GS.cellConfig.label.preview, "BOTTOMRIGHT", 19, 0)
				GS.cellConfig.label.blue:SetFontColor(1,1,1,1)
				GS.cellConfig.label.blue:SetFontSize(12)
				GS.cellConfig.label.blue:SetText("Blue")
			
			GS.cellConfig.label.blue.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_label_blue_slider", GS.cellConfig.label.blue)
				GS.cellConfig.label.blue.slider:SetPoint("CENTERLEFT", GS.cellConfig.label.blue, "CENTERRIGHT", 12, 6)
				GS.cellConfig.label.blue.slider:SetRange(0,255)
				GS.cellConfig.label.blue.slider:SetWidth(120)
				GS.cellConfig.label.blue.slider:SetPosition(255)
				GS.cellConfig.label.blue.slider.Event.SliderChange = function()
					GS.cellConfig.label.blue.value:SetText(tostring(GS.cellConfig.label.blue.slider:GetPosition()))
					GS.cellConfig.label.preview:SetBackgroundColor(GS.cellConfig.label.red.slider:GetPosition()/255,GS.cellConfig.label.green.slider:GetPosition()/255,GS.cellConfig.label.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.label.blue.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_label_blue_value", GS.cellConfig.label.blue)
				GS.cellConfig.label.blue.value:SetPoint("CENTERLEFT", GS.cellConfig.label.blue.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.label.blue.value:SetFontColor(1,1,1,1)
				GS.cellConfig.label.blue.value:SetFontSize(12)
				GS.cellConfig.label.blue.value:SetText(tostring(GS.cellConfig.label.blue.slider:GetPosition()))
				
		GS.cellConfig.stat = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat", GS.cellConfig)
			GS.cellConfig.stat:SetPoint("TOPLEFT", GS.cellConfig.label, "TOPLEFT", 0, 100)
			GS.cellConfig.stat:SetFontColor(1,1,1,1)
			GS.cellConfig.stat:SetFontSize(14)
			GS.cellConfig.stat:SetText("Stat Color")
			
			GS.cellConfig.stat.preview = UI.CreateFrame("Frame", AddonId .. "_cellConfig_stat_preview", GS.cellConfig.stat)
				GS.cellConfig.stat.preview:SetPoint("TOPLEFT", GS.cellConfig.stat, "BOTTOMLEFT", 0, 5)
				GS.cellConfig.stat.preview:SetHeight(60)
				GS.cellConfig.stat.preview:SetWidth(45)
				GS.cellConfig.stat.preview:SetBackgroundColor(1,1,1,1)
			
			GS.cellConfig.stat.red = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat_red", GS.cellConfig.stat)
				GS.cellConfig.stat.red:SetPoint("TOPLEFT", GS.cellConfig.stat.preview, "TOPRIGHT", 22, 0)
				GS.cellConfig.stat.red:SetFontColor(1,1,1,1)
				GS.cellConfig.stat.red:SetFontSize(12)
				GS.cellConfig.stat.red:SetText("Red")
			
			GS.cellConfig.stat.red.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_stat_red_slider", GS.cellConfig.stat.red)
				GS.cellConfig.stat.red.slider:SetPoint("CENTERLEFT", GS.cellConfig.stat.red, "CENTERRIGHT", 12, 6)
				GS.cellConfig.stat.red.slider:SetRange(0,255)
				GS.cellConfig.stat.red.slider:SetWidth(120)
				GS.cellConfig.stat.red.slider:SetPosition(255)
				GS.cellConfig.stat.red.slider.Event.SliderChange = function()
					GS.cellConfig.stat.red.value:SetText(tostring(GS.cellConfig.stat.red.slider:GetPosition()))
					GS.cellConfig.stat.preview:SetBackgroundColor(GS.cellConfig.stat.red.slider:GetPosition()/255,GS.cellConfig.stat.green.slider:GetPosition()/255,GS.cellConfig.stat.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.stat.red.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat_red_value", GS.cellConfig.stat.red)
				GS.cellConfig.stat.red.value:SetPoint("CENTERLEFT", GS.cellConfig.stat.red.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.stat.red.value:SetFontColor(1,1,1,1)
				GS.cellConfig.stat.red.value:SetFontSize(12)
				GS.cellConfig.stat.red.value:SetText(tostring(GS.cellConfig.stat.red.slider:GetPosition()))
			
			GS.cellConfig.stat.green = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat_green", GS.cellConfig.stat)
				GS.cellConfig.stat.green:SetPoint("CENTERLEFT", GS.cellConfig.stat.preview, "CENTERRIGHT", 10, 0)
				GS.cellConfig.stat.green:SetFontColor(1,1,1,1)
				GS.cellConfig.stat.green:SetFontSize(12)
				GS.cellConfig.stat.green:SetText("Green")
			
			GS.cellConfig.stat.green.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_stat_green_slider", GS.cellConfig.stat.green)
				GS.cellConfig.stat.green.slider:SetPoint("CENTERLEFT", GS.cellConfig.stat.green, "CENTERRIGHT", 12, 6)
				GS.cellConfig.stat.green.slider:SetRange(0,255)
				GS.cellConfig.stat.green.slider:SetWidth(120)
				GS.cellConfig.stat.green.slider:SetPosition(255)
				GS.cellConfig.stat.green.slider.Event.SliderChange = function()
					GS.cellConfig.stat.green.value:SetText(tostring(GS.cellConfig.stat.green.slider:GetPosition()))
					GS.cellConfig.stat.preview:SetBackgroundColor(GS.cellConfig.stat.red.slider:GetPosition()/255,GS.cellConfig.stat.green.slider:GetPosition()/255,GS.cellConfig.stat.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.stat.green.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat_green_value", GS.cellConfig.stat.green)
				GS.cellConfig.stat.green.value:SetPoint("CENTERLEFT", GS.cellConfig.stat.green.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.stat.green.value:SetFontColor(1,1,1,1)
				GS.cellConfig.stat.green.value:SetFontSize(12)
				GS.cellConfig.stat.green.value:SetText(tostring(GS.cellConfig.stat.green.slider:GetPosition()))
			
			GS.cellConfig.stat.blue = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat_blue", GS.cellConfig.stat)
				GS.cellConfig.stat.blue:SetPoint("BOTTOMLEFT", GS.cellConfig.stat.preview, "BOTTOMRIGHT", 19, 0)
				GS.cellConfig.stat.blue:SetFontColor(1,1,1,1)
				GS.cellConfig.stat.blue:SetFontSize(12)
				GS.cellConfig.stat.blue:SetText("Blue")
			
			GS.cellConfig.stat.blue.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_stat_blue_slider", GS.cellConfig.stat.blue)
				GS.cellConfig.stat.blue.slider:SetPoint("CENTERLEFT", GS.cellConfig.stat.blue, "CENTERRIGHT", 12, 6)
				GS.cellConfig.stat.blue.slider:SetRange(0,255)
				GS.cellConfig.stat.blue.slider:SetWidth(120)
				GS.cellConfig.stat.blue.slider:SetPosition(255)
				GS.cellConfig.stat.blue.slider.Event.SliderChange = function()
					GS.cellConfig.stat.blue.value:SetText(tostring(GS.cellConfig.stat.blue.slider:GetPosition()))
					GS.cellConfig.stat.preview:SetBackgroundColor(GS.cellConfig.stat.red.slider:GetPosition()/255,GS.cellConfig.stat.green.slider:GetPosition()/255,GS.cellConfig.stat.blue.slider:GetPosition()/255,1)
				end
			
			GS.cellConfig.stat.blue.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_stat_blue_value", GS.cellConfig.stat.blue)
				GS.cellConfig.stat.blue.value:SetPoint("CENTERLEFT", GS.cellConfig.stat.blue.slider, "CENTERRIGHT", 12, -6)
				GS.cellConfig.stat.blue.value:SetFontColor(1,1,1,1)
				GS.cellConfig.stat.blue.value:SetFontSize(12)
				GS.cellConfig.stat.blue.value:SetText(tostring(GS.cellConfig.stat.blue.slider:GetPosition()))
				
		GS.cellConfig.alpha = UI.CreateFrame("Text", AddonId .. "_cellConfig_alpha", GS.cellConfig)
			GS.cellConfig.alpha:SetPoint("TOPLEFT", GS.cellConfig.stat.preview, "BOTTOMRIGHT", 11, 20)
			GS.cellConfig.alpha:SetFontColor(1,1,1,1)
			GS.cellConfig.alpha:SetFontSize(12)
			GS.cellConfig.alpha:SetText("Alpha")
			
		GS.cellConfig.alpha.slider = UI.CreateFrame("RiftSlider", AddonId .. "_cellConfig_alpha_slider", GS.cellConfig.alpha)
			GS.cellConfig.alpha.slider:SetPoint("CENTERLEFT", GS.cellConfig.alpha, "CENTERRIGHT", 12, 6)
			GS.cellConfig.alpha.slider:SetRange(0,100)
			GS.cellConfig.alpha.slider:SetWidth(120)
			GS.cellConfig.alpha.slider:SetPosition(50)
			GS.cellConfig.alpha.slider.Event.SliderChange = function()
				GS.cellConfig.alpha.value:SetText(tostring(GS.cellConfig.alpha.slider:GetPosition()))
			end
			
		GS.cellConfig.alpha.value = UI.CreateFrame("Text", AddonId .. "_cellConfig_alpha_value", GS.cellConfig.alpha)
			GS.cellConfig.alpha.value:SetPoint("CENTERLEFT", GS.cellConfig.alpha.slider, "CENTERRIGHT", 12, -6)
			GS.cellConfig.alpha.value:SetFontColor(1,1,1,1)
			GS.cellConfig.alpha.value:SetFontSize(12)
			GS.cellConfig.alpha.value:SetText(tostring(GS.cellConfig.alpha.slider:GetPosition()))
			
		GS.cellConfig.shortName = UI.CreateFrame("Text", AddonId .. "_cellConfig_shortName", GS.cellConfig)
			GS.cellConfig.shortName:SetPoint("TOPLEFT", GS.cellConfig.alpha, "BOTTOMLEFT", 0, 15)
			GS.cellConfig.shortName:SetFontColor(1,1,1,1)
			GS.cellConfig.shortName:SetFontSize(12)
			GS.cellConfig.shortName:SetVisible(false)
			GS.cellConfig.shortName:SetText("Use Shortened Name?")
			
		GS.cellConfig.shortName.check = UI.CreateFrame("RiftCheckbox", AddonId .. "_cellConfig_shortName_check", GS.cellConfig.shortName)
			GS.cellConfig.shortName.check:SetPoint("CENTERLEFT", GS.cellConfig.shortName, "CENTERRIGHT", 59, 0)
			GS.cellConfig.shortName.check:SetHeight(20)
			GS.cellConfig.shortName.check:SetWidth(20)
			GS.cellConfig.shortName.check:SetEnabled(true)
			
		if cellInfo.stext then
			GS.cellConfig.shortName:SetVisible(true)
		end
	end
	
	if cellInfo then
		GS.cellConfig:SetVisible(true)
		GS.cellConfig.bg:SetText("Background Color                 Cell: " .. cellInfo.row .. ", " .. cellInfo.column)
		local bgr,bgg,bgb = cellInfo.back:GetBackgroundColor()
		local lblr,lblg,lblb = cellInfo.text:GetFontColor()
		GS.cellConfig.bg.preview:SetBackgroundColor(bgr,bgg,bgb,1)
		GS.cellConfig.bg.red.slider:SetPosition(math.floor(bgr*255))
		GS.cellConfig.bg.green.slider:SetPosition(math.floor(bgg*255))
		GS.cellConfig.bg.blue.slider:SetPosition(math.floor(bgb*255))
		GS.cellConfig.label.preview:SetBackgroundColor(lblr,lblg,lblb,1)
		GS.cellConfig.label.red.slider:SetPosition(math.floor(lblr*255))
		GS.cellConfig.label.green.slider:SetPosition(math.floor(lblg*255))
		GS.cellConfig.label.blue.slider:SetPosition(math.floor(lblb*255))
		if cellInfo.statr and cellInfo.statg and cellInfo.statb and cellInfo.alpha then
			GS.cellConfig.stat.preview:SetBackgroundColor(cellInfo.statr,cellInfo.statg,cellInfo.statb,1)
			GS.cellConfig.stat.red.slider:SetPosition(math.floor(cellInfo.statr*255))
			GS.cellConfig.stat.green.slider:SetPosition(math.floor(cellInfo.statg*255))
			GS.cellConfig.stat.blue.slider:SetPosition(math.floor(cellInfo.statb*255))
			GS.cellConfig.alpha.slider:SetPosition(math.floor(cellInfo.alpha*100))
		else
			GS.cellConfig.stat.preview:SetBackgroundColor(1,1,1,1)
			GS.cellConfig.stat.red.slider:SetPosition(255)
			GS.cellConfig.stat.green.slider:SetPosition(255)
			GS.cellConfig.stat.blue.slider:SetPosition(255)
			GS.cellConfig.alpha.slider:SetPosition(50)
		end
		if cellInfo.stext then
			GS.cellConfig.shortName:SetVisible(true)
			if cellInfo.useStext == true then
				checkbox = cellInfo.useStext
				GS.cellConfig.shortName.check:SetChecked(true)
			elseif cellInfo.useStext == false then
				checkbox = cellInfo.useStext
				GS.cellConfig.shortName.check:SetChecked(false)
			else
				GS.cellConfig.shortName.check:SetChecked(false)
			end
		else
			GS.cellConfig.shortName:SetVisible(false)
		end
	end
	
	function GS.cellConfig.btnOK.Event.LeftPress()
		cellInfo.back:SetBackgroundColor(GS.cellConfig.bg.red.slider:GetPosition()/255,GS.cellConfig.bg.green.slider:GetPosition()/255,GS.cellConfig.bg.blue.slider:GetPosition()/255,1)
		cellInfo.text:SetFontColor(GS.cellConfig.label.red.slider:GetPosition()/255,GS.cellConfig.label.green.slider:GetPosition()/255,GS.cellConfig.label.blue.slider:GetPosition()/255,1)
		cellInfo.statr = GS.cellConfig.stat.red.slider:GetPosition()/255
		cellInfo.statg = GS.cellConfig.stat.green.slider:GetPosition()/255
		cellInfo.statb = GS.cellConfig.stat.blue.slider:GetPosition()/255
		cellInfo.alpha = GS.cellConfig.alpha.slider:GetPosition()/100
		if cellInfo.stext then
			checkbox = GS.cellConfig.shortName.check:GetChecked()
		end
		if checkbox == true then
			cellInfo.useStext = checkbox
			cellInfo.text:SetText(cellInfo.stext)
		elseif checkbox == false then
			cellInfo.useStext = checkbox
			cellInfo.text:SetText(cellInfo.ltext)
		end
		GS.cellConfig:SetVisible(false)
		GS.cellConfig.shortName.check:SetChecked(false)
	end

end

local function Create(configuration)

	Command.System.Watchdog.Quiet()

	local rowText = configuration.rowText
	local columnText = configuration.columnText
	local statList = Inspect.Stat()
	
	GS.configTable = {}
	for idx = 1, 10, 1 do
		table.insert(GS.configTable, configuration[idx])
	end

	GS.display[configuration.id] = UI.CreateFrame("Frame", AddonId .. "_display_" .. configuration.id, WT.Context)
		GS.display[configuration.id]:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 350, 350)
		GS.display[configuration.id]:SetHeight(rowText*20)
		GS.display[configuration.id]:SetWidth(columnText*175)
		GS.display[configuration.id]:SetLayer(5)
		
		GS.display[configuration.id].data = {}
		
	for column, rows in ipairs(GS.configTable) do
	
		GS.display[configuration.id].data[column] = {}
		
		for row, data in ipairs(rows) do
			if data.name then
			
			local statNum = 0
			
			if statList == nil then
				statNum = 0
			else
				statNum = statList[data.name]
			end
			
			if not data.Colors then
				data.Colors = { Back = {0,0,0,0.5}, Label = {1,1,1}, Stat = {1,1,1}}
			end
			
			local cell = UI.CreateFrame("Frame", AddonId .. "_display_" .. configuration.id .. "_" .. column .. "_" .. row, GS.display[configuration.id])
				cell:SetPoint("TOPLEFT", GS.display[configuration.id], "TOPLEFT", 175*(column-1), 20*(row-1))
				cell:SetHeight(20)
				cell:SetWidth(175)
				cell:SetBackgroundColor(data.Colors.Back[1],data.Colors.Back[2],data.Colors.Back[3],data.Colors.Back[4])
				cell:SetLayer(10)
				
			cell.text = UI.CreateFrame("Text", AddonId .. "_display_" .. configuration.id .. "_" .. column .. "_" .. row .. "_text", cell)
				cell.text:SetPoint("CENTERLEFT", cell, "CENTERLEFT", 2, 0)
				cell.text:SetFontColor(data.Colors.Label[1],data.Colors.Label[2],data.Colors.Label[3],1)
				cell.text:SetFontSize(14)
				cell.text:SetText((data.text.text or data.text))
				cell.text:SetVisible(true)
				cell.text:SetLayer(20)

			cell.stat = UI.CreateFrame("Text", AddonId .. "_display_" .. configuration.id .. "_" .. column .. "_" .. row .. "_stat", cell)
				cell.stat:SetPoint("CENTERRIGHT", cell, "CENTERRIGHT", -2, 0)
				cell.stat:SetFontColor(data.Colors.Stat[1],data.Colors.Stat[2],data.Colors.Stat[3],1)
				cell.stat:SetFontSize(14)
				cell.stat:SetText(tostring(statNum))
				cell.stat:SetVisible(true)
				cell.stat:SetLayer(20)
					
			cell.name = data.name
			
			GS.display[configuration.id].data[column][row] = cell
			end
		end
	end
	if GS.layout then
		GS.layout.SetText(1,1)
	end
	if GS.preview then
		for cell, data in pairs(GS.preview.view:GetChildren()) do
			cell.back:SetBackgroundColor(0.5,0.5,0.5,1)
			cell.text:SetFontColor(1,1,1,1)
			cell.statr = nil
			cell.statg = nil
			cell.statb = nil
			cell.alpha = nil
			cell.text:SetText("")
			cell.text:SetVisible(false)
			cell.cname = nil
			cell.ltext = nil
			if cell.stext then
				cell.stext = nil
			end
		end
	end
	--[[display.Event.Size = 
		function()
			for column, rows in ipairs(display.data) do
				for row, data in ipairs(rows) do]]--
	
	return GS.display[configuration.id]--, { resizable={(columnText*175), (rowText*20), (columnText*875), (rowText*100) } }

end

local dialog = false

local function ConfigDialog(container)

	Command.System.Watchdog.Quiet()
	
	GS.container = container

	GS.label = UI.CreateFrame("Text", AddonId .. "_label", container)
		GS.label:SetPoint("TOPLEFT", container, "TOPLEFT")
		GS.label:SetPoint("RIGHT", container, "RIGHT")
		GS.label:SetFontSize(12)
		GS.label:SetText("The Stats Gadget shows the selected stats for the player.")
	
	GS.layout = UI.CreateFrame("Frame", AddonId .. "_layout", container)
		GS.layout:SetPoint("TOPLEFT", GS.label, "BOTTOMLEFT", 0, 5)
		GS.layout:SetPoint("RIGHT", container, "RIGHT")
		GS.layout:SetHeight(20)
		
		GS.layout.label = UI.CreateFrame("Text", AddonId .. "_layout_label", GS.layout)
			GS.layout.label:SetText("Layout")
			GS.layout.label:SetWidth(200)
			GS.layout.label:SetPoint("TOPLEFT", GS.layout, "TOPLEFT")
			
		GS.layout.Rows = {}
		
		GS.layout.Rows.label = UI.CreateFrame("Text", AddonId .. "_layout_Rows_label", GS.layout)
			GS.layout.Rows.label:SetText("Rows:")
			GS.layout.Rows.label:SetPoint("CENTERLEFT", GS.layout.label, "CENTERRIGHT", 8, 0)
		
		GS.layout.Rows.value = UI.CreateFrame("Text", AddonId .. "_layout_Rows_value", GS.layout)
			GS.layout.Rows.value:SetText("1")
			GS.layout.Rows.value:SetWidth(50)
			GS.layout.Rows.value:SetBackgroundColor(0.2,0.2,0.2,0.9)
			GS.layout.Rows.value:SetPoint("CENTERLEFT", GS.layout.Rows.label, "CENTERRIGHT", 5, 0)
			
		GS.layout.Rows.Icon = UI.CreateFrame("Texture", AddonId .. "_layout_Rows_Icon", GS.layout.Rows.value)
			GS.layout.Rows.Icon:SetTexture(AddonId, "img/wtDropDown.png")
			GS.layout.Rows.Icon:SetHeight(GS.layout.Rows.value:GetHeight())
			GS.layout.Rows.Icon:SetWidth(GS.layout.Rows.value:GetHeight())
			GS.layout.Rows.Icon:SetPoint("TOPLEFT", GS.layout.Rows.value, "TOPRIGHT", -10, 0)
			
		GS.layout.Rows.menu = WT.Control.Menu.Create(container, { "1       ", "2", "3", "4", "5", "6", "7", "8", "9", "10" }, function(value) GS.layout.Rows.value:SetText(value); previewUpdate("row", value) end, sort)
			GS.layout.Rows.menu:SetPoint("TOPRIGHT", GS.layout.Rows.Icon, "BOTTOMCENTER")
			
		GS.layout.Rows.Icon.Event.LeftClick = function() GS.layout.Rows.menu:Toggle() end
		GS.layout.Rows.value.Event.LeftClick = function() GS.layout.Rows.menu:Toggle() end
		
		GS.layout.Columns = {}
		
		GS.layout.Columns.label = UI.CreateFrame("Text", AddonId .. "_layout_Columns_label", GS.layout)
			GS.layout.Columns.label:SetText("Columns:")
			GS.layout.Columns.label:SetPoint("CENTERLEFT", GS.layout.Rows.Icon, "CENTERRIGHT", 20, 0)
			
		GS.layout.Columns.value = UI.CreateFrame("Text", AddonId .. "_layout_Columns_value", GS.layout)
			GS.layout.Columns.value:SetText("1")
			GS.layout.Columns.value:SetWidth(50)
			GS.layout.Columns.value:SetBackgroundColor(0.2,0.2,0.2,0.9)
			GS.layout.Columns.value:SetPoint("CENTERLEFT", GS.layout.Columns.label, "CENTERRIGHT", 5, 0)
			
		GS.layout.Columns.Icon = UI.CreateFrame("Texture", AddonId .. "_layout_Columns_Icon", GS.layout.Columns.value)
			GS.layout.Columns.Icon:SetTexture(AddonId, "img/wtDropDown.png")
			GS.layout.Columns.Icon:SetHeight(GS.layout.Columns.value:GetHeight())
			GS.layout.Columns.Icon:SetWidth(GS.layout.Columns.value:GetHeight())
			GS.layout.Columns.Icon:SetPoint("TOPLEFT", GS.layout.Columns.value, "TOPRIGHT", -10, 0)
			
		GS.layout.Columns.menu = WT.Control.Menu.Create(container, { "1       ", "2", "3", "4", "5", "6", "7", "8", "9", "10" }, function(value) GS.layout.Columns.value:SetText(value); previewUpdate("column", value) end, sort)
			GS.layout.Columns.menu:SetPoint("TOPRIGHT", GS.layout.Columns.Icon, "BOTTOMCENTER")
			
		GS.layout.Columns.Icon.Event.LeftClick = function() GS.layout.Columns.menu:Toggle() end
		GS.layout.Columns.value.Event.LeftClick = function() GS.layout.Columns.menu:Toggle() end
		
		
		GS.layout.GetText = function() return {GS.layout.Rows.value:GetText(), GS.layout.Columns.value:GetText()} end
		GS.layout.SetText = 
			function(row,column)
				if row then
					GS.layout.Rows.value:SetText(tostring(row))
					if onchange then onchange(tostring(row)) end
					previewUpdate("row", row)
				end
				if column then
					GS.layout.Columns.value:SetText(tostring(column))
					if onchange then onchange(tostring(column)) end
					previewUpdate("column", column)
				end
				for cell, data in pairs(GS.preview.view:GetChildren()) do
					cell.text:SetText("")
					cell.back:SetBackgroundColor(0.5,0.5,0.5,1)
					cell.text:SetVisible(true)
					if cell.cname then
						cell.cname = nil
					end
				end
			end
			
	GS.stats = UI.CreateFrame("Frame", AddonId .. "_stats", container)
		GS.stats.label = UI.CreateFrame("Text", AddonId .. "_stats_label", GS.stats)
			GS.stats.label:SetPoint("TOPLEFT", GS.layout, "BOTTOMLEFT", 0, 10)
			GS.stats.label:SetPoint("RIGHT", container, "RIGHT")
			GS.stats.label:SetFontSize(12)
			GS.stats.label:SetText("Drag the desired stats into an open cell in the preview window below.")
		
		GS.stats:SetPoint("TOPLEFT", GS.stats.label, "BOTTOMLEFT", 5, 3)
		GS.stats:SetHeight(180)
		GS.stats:SetWidth(483)
		GS.stats:SetBackgroundColor(0.2,0.2,0.2,0.9)
		GS.stats.Event.WheelForward = function()
			GS.stats.scrollbar:NudgeUp()
		end
		GS.stats.Event.WheelBack = function()
			GS.stats.scrollbar:NudgeDown()
		end
		
		GS.stats.view = UI.CreateFrame("Frame", AddonId .. "_stats_view", GS.stats)
			GS.stats.view:SetPoint("TOPLEFT", GS.stats, "TOPLEFT")
			GS.stats.view:SetHeight(180)

		GS.stats.scrollbar = UI.CreateFrame("RiftScrollbar", AddonId .. "_stats_scrollbar", GS.stats)
			GS.stats.scrollbar:SetPoint("TOPLEFT", GS.stats, "TOPRIGHT", 5, 0)
			GS.stats.scrollbar:SetPoint("BOTTOMLEFT", GS.stats, "BOTTOMRIGHT", 5, 0)
			GS.stats.scrollbar:SetThickness(15)
			GS.stats.scrollbar:SetRange(1,14)
			GS.stats.scrollbar.Event.WheelForward = function()
				GS.stats.scrollbar:NudgeUp()
			end
			GS.stats.scrollbar.Event.WheelBack = function()
				GS.stats.scrollbar:NudgeDown()
			end
			GS.stats.scrollbar.Event.ScrollbarChange = function()
				local pos = math.floor(GS.stats.scrollbar:GetPosition())-1
				GS.stats.view:SetPoint("TOPLEFT", GS.stats, "TOPLEFT", 0, -(pos*20))
				for cell,data in pairs(GS.stats.view:GetChildren()) do
					if cell.row <= pos or cell.row > pos+9 then
						cell:SetVisible(false)
					else
						cell:SetVisible(true)
					end
				end
			end
		
	statsCurRow = 0
	statsCurCol = 0
	statsLastRow = GS.stats.view
	
	local function addCell(name, text, col, stext)
	
		if col == statsCurCol then
			statsCurRow = statsCurRow + 1
		else
			statsCurRow = 1
			statsCurCol = col
		end
		
		local cell = UI.CreateFrame("Frame", AddonId .. "_stats_view_" .. name, GS.stats.view)
			if statsCurCol == 0 then
				if statsCurRow == 1 then
					cell:SetPoint("TOPLEFT", GS.stats.view, "TOPLEFT")
				else
					cell:SetPoint("TOPLEFT", statsLastRow, "BOTTOMLEFT")
				end
			elseif statsCurCol == 1 then
			if statsCurRow == 1 then
					cell:SetPoint("TOPLEFT", GS.stats.view, "TOPLEFT", 161, 0)
				else
					cell:SetPoint("TOPLEFT", statsLastRow, "BOTTOMLEFT")
				end
			elseif statsCurCol == 2 then
			if statsCurRow == 1 then
					cell:SetPoint("TOPLEFT", GS.stats.view, "TOPLEFT", 322, 0)
				else
					cell:SetPoint("TOPLEFT", statsLastRow, "BOTTOMLEFT")
				end
			end
			cell.row = statsCurRow
			cell.column = col
			cell:SetHeight(20)
			cell:SetWidth(161)
			cell:SetBackgroundColor(1,1,1,0)
			cell:SetLayer(10)
			cell.Event.MouseIn = function() cell:SetBackgroundColor(1,1,1,1) end
			cell.Event.MouseOut = function() cell:SetBackgroundColor(1,1,1,0) end
			function cell.Event.LeftDown()
				if cell.row ~= 1 and cell.text:GetText() ~= "" then
					mouseFrame.text:SetText(text)
					mouseFrame:SetVisible(true)
					mouseFrame.cname = name
					if stext then
						mouseFrame.stext = stext
					end
					
					local mouse = Inspect.Mouse()
					mouseFrame:SetPoint("CENTER", WT.Context, "CENTER", mouse.x-18, mouse.y-18)
					
				end
			end
			function cell.Event.LeftUp()
				mouseFrame:SetVisible(false)
			end
			function cell.Event.LeftUpoutside()
				mouseFrame:SetVisible(false)
			end
			
		cell.back = UI.CreateFrame("Frame", AddonId .. "_stats_view_" .. name .. "_back", cell)
			cell.back:SetPoint("TOPLEFT", cell, "TOPLEFT", 2, 2)
			cell.back:SetPoint("BOTTOMRIGHT", cell, "BOTTOMRIGHT", -2, -2)
			cell.back:SetBackgroundColor(0,0,0,1)
			cell.back:SetVisible(true)
			cell.back:SetLayer(20)
		
		cell.text = UI.CreateFrame("Text", AddonId .. "_stats_view_" .. name .. "_text", cell.back)
			cell.text:SetPoint("CENTERLEFT", cell.back, "CENTERLEFT", 2, 0)
			cell.text:SetWidth(cell.back:GetWidth()-4)
			cell.text:SetFontColor(1,1,1,1)
			cell.text:SetFontSize(14)
			cell.text:SetText(text)
			cell.text:SetVisible(true)
			cell.text:SetLayer(30)
			
		if cell.row > 9 then
			cell:SetVisible(false)
		end
			
		statsLastRow = cell
		
	end
	
	addCell("mainStats", "Main", 0)
	addCell("armor", "Armor", 0)
	addCell("endurance", "Endurance", 0, "Endu")
	addCell("strength", "Strength", 0, "Str")
	addCell("dexterity", "Dexterity", 0, "Dex")
	addCell("intelligence", "Intelligence", 0, "Int")
	addCell("wisdom", "Wisdom", 0, "Wis")
	addCell("spacer0", "", 0)
	addCell("armorUnbuffed", "Unbuffed Armor", 0)
	addCell("enduranceUnbuffed", "Unbuffed Endurance", 0, "Unbuffed Endu")
	addCell("strengthUnbuffed", "Unbuffed Strength", 0, "Unbuffed Str")
	addCell("dexterityUnbuffed", "Unbuffed Dexterity", 0, "Unbuffed Dex")
	addCell("intelligenceUnbuffed", "Unbuffed Intelligence", 0, "Unbuffed Int")
	addCell("wisdomUnbuffed", "Unbuffed Wisdom", 0, "Unbuffed Wis")

	addCell("defenseStats", "Tank and Resist", 1)
	addCell("dodge", "Dodge", 1)
	addCell("block", "Block", 1)
	addCell("guard", "Guard", 1)
	addCell("resistLife", "Life Resist", 1)
	addCell("resistDeath", "Death Resist", 1)
	addCell("resistFire", "Fire Resist", 1)
	addCell("resistWater", "Water Resist", 1)
	addCell("resistEarth", "Earth Resist", 1)
	addCell("resistAir", "Air Resist", 1)
	addCell("spacer1", "", 1)
	addCell("dodgeUnbuffed", "Unbuffed Dodge", 1)
	addCell("blockUnbuffed", "Unbuffed Block", 1)
	addCell("guardUnbuffed", "Unbuffed Guard", 1)
	addCell("resistLifeUnbuffed", "Unbuffed Life Resist", 1)
	addCell("resistDeathUnbuffed", "Unbuffed Death Resist", 1)
	addCell("resistFireUnbuffed", "Unbuffed Fire Resist", 1)
	addCell("resistWaterUnbuffed", "Unbuffed Water Resist", 1)
	addCell("resistEarthUnbuffed", "Unbuffed Earth Resist", 1)
	addCell("resistAirUnbuffed", "Unbuffed Air Resist", 1)

	addCell("attackStats", "Melee/Ranged and Spell", 2)
	addCell("powerAttack", "Attack Power", 2, "AP")
	addCell("critAttack", "Physical Crit", 2, "PC")
	addCell("powerSpell", "Spell Power", 2, "SP")
	addCell("critSpell", "Spell Crit", 2, "SC")
	addCell("critPower", "Crit Power", 2, "CP")
	addCell("hit", "Hit", 2)
	addCell("spacer2", "", 2)
	addCell("powerAttackUnbuffed", "Unbuffed Attack Power", 2, "Unbuffed AP")
	addCell("critAttackUnbuffed", "Unbuffed Physical Crit", 2, "Unbuffed PC")
	addCell("powerSpellUnbuffed", "Unbuffed Spell Power", 2, "Unbuffed SP")
	addCell("critSpellUnbuffed", "Unbuffed Spell Crit", 2, "Unbuffed SC")
	addCell("critPowerUnbuffed", "Unbuffed Crit Power", 2, "Unbuffed CP")
	addCell("hitUnbuffed", "Unbuffed Hit", 2)
	
	
	GS.preview = UI.CreateFrame("Frame", AddonId .. "_preview", container)
		GS.preview.label = UI.CreateFrame("Text", AddonId .. "_preview_label", GS.preview)
			GS.preview.label:SetPoint("TOPLEFT", GS.stats, "BOTTOMLEFT", -5, 7)
			GS.preview.label:SetPoint("RIGHT", container, "RIGHT")
			GS.preview.label:SetFontSize(12)
			GS.preview.label:SetText("Right click on a cell for additional options specific to that cell.")
			
		GS.preview:SetPoint("TOPLEFT", GS.preview.label, "BOTTOMLEFT", 5, 3)
		GS.preview:SetHeight(120)
		GS.preview:SetWidth(483)
		GS.preview:SetBackgroundColor(0.2,0.2,0.2,0.9)
		GS.preview.Event.WheelForward = function()
			GS.preview.scrollbarUp:NudgeUp()
		end
		GS.preview.Event.WheelBack = function()
			GS.preview.scrollbarUp:NudgeDown()
		end
		
		GS.preview.view = UI.CreateFrame("Frame", AddonId .. "_preview_view", GS.preview)
			GS.preview.view:SetPoint("TOPLEFT", GS.preview, "TOPLEFT")
			GS.preview.view:SetHeight(120)

		GS.preview.scrollbarUp = UI.CreateFrame("RiftScrollbar", AddonId .. "_preview_scrollbarUp", GS.preview)
			GS.preview.scrollbarUp:SetPoint("TOPLEFT", GS.preview, "TOPRIGHT", 5, 0)
			GS.preview.scrollbarUp:SetPoint("BOTTOMLEFT", GS.preview, "BOTTOMRIGHT", 5, 0)
			GS.preview.scrollbarUp:SetThickness(15)
			GS.preview.scrollbarUp:SetRange(1,1)
			GS.preview.scrollbarUp.Event.WheelForward = function()
				GS.preview.scrollbarUp:NudgeUp()
			end
			GS.preview.scrollbarUp.Event.WheelBack = function()
				GS.preview.scrollbarUp:NudgeDown()
			end
			GS.preview.scrollbarUp.Event.ScrollbarChange = function()
				local posUp = math.floor(GS.preview.scrollbarUp:GetPosition())-1
				local posSide = math.floor(GS.preview.scrollbarSide:GetPosition())-1
				local ctext = GS.layout.Columns.value:GetText()
				GS.preview.view:SetPoint("TOPLEFT", GS.preview, "TOPLEFT", -(posSide*161), -(posUp*20))
				for cell,data in pairs(GS.preview.view:GetChildren()) do
					if cell.column > posSide and cell.column <= posSide+3 and cell.column <= toNum(ctext) then
						if cell.row > posUp and cell.row <= posUp+6 then
							cell:SetVisible(true)
						else
							cell:SetVisible(false)
						end
					else
						cell:SetVisible(false)
					end
				end
			end
			
		GS.preview.scrollbarSide = UI.CreateFrame("RiftScrollbar", AddonId .. "_preview_scrollbarSide", GS.preview.view)
			GS.preview.scrollbarSide:SetOrientation("horizontal")
			GS.preview.scrollbarSide:SetParent(GS.preview)
			GS.preview.scrollbarSide:SetPoint("TOPLEFT", GS.preview, "BOTTOMLEFT", 0, 5)
			GS.preview.scrollbarSide:SetPoint("TOPRIGHT", GS.preview, "BOTTOMRIGHT", 0, 5)
			GS.preview.scrollbarSide:SetThickness(15)
			GS.preview.scrollbarSide:SetRange(1,1)
			GS.preview.scrollbarSide.Event.ScrollbarChange = function()
				local posUp = math.floor(GS.preview.scrollbarUp:GetPosition())-1
				local posSide = math.floor(GS.preview.scrollbarSide:GetPosition())-1
				local rtext = GS.layout.Rows.value:GetText()
				GS.preview.view:SetPoint("TOPLEFT", GS.preview, "TOPLEFT", -(posSide*161), -(posUp*20))
				for cell,data in pairs(GS.preview.view:GetChildren()) do
					if cell.row > posUp and cell.row <= posUp+6 and cell.row <= toNum(rtext) then
						if cell.column > posSide and cell.column <= posSide+3 then
							cell:SetVisible(true)
						else
							cell:SetVisible(false)
						end
					else
						cell:SetVisible(false)
					end
				end
			end
		
		previewLastRow = GS.preview.view
	
		for pCol = 1, 10, 1 do
			for pRow = 1, 10, 1 do
				local name = "cell_" .. pRow .. "_" .. pCol
				local cell = UI.CreateFrame("Frame", name, GS.preview.view)
					if pCol == 1 then
						if pRow == 1 then
							cell:SetPoint("TOPLEFT", GS.preview.view, "TOPLEFT")
						else
							cell:SetPoint("TOPLEFT", previewLastRow, "BOTTOMLEFT")
						end
					elseif pCol > 1 then
						if pRow == 1 then
							cell:SetPoint("TOPLEFT", GS.preview.view, "TOPLEFT", (161*(pCol-1)), 0)
						else
							cell:SetPoint("TOPLEFT", previewLastRow, "BOTTOMLEFT")
						end
					end
					cell.row = pRow
					cell.column = pCol
					cell:SetHeight(20)
					cell:SetWidth(161)
					cell:SetBackgroundColor(1,1,1,0)
					cell:SetLayer(10)
					cell.Event.MouseIn = function() cell:SetBackgroundColor(1,1,1,1) end
					cell.Event.MouseOut = function() cell:SetBackgroundColor(1,1,1,0) end
					function cell.Event.LeftDown()
						if cell.text:GetText() ~= "" then
							mouseFrame.text:SetText(cell.ltext)
							mouseFrame:SetVisible(true)
							mouseFrame.cname = cell.cname
							if cell.stext then
								mouseFrame.stext = cell.stext
							end
							local mouse = Inspect.Mouse()
							mouseFrame:SetPoint("CENTER", WT.Context, "CENTER", mouse.x-18, mouse.y-18)
						end
					end
					function cell.Event.LeftUp()
						mouseFrame:SetVisible(false)
						if mouseFrame.text:GetText() ~= "" then
							cell.text:SetText(mouseFrame.text:GetText())
							cell.text:SetVisible(true)
							cell.back:SetBackgroundColor(0,0,0,1)
							cell.cname = mouseFrame.cname
							cell.ltext = mouseFrame.text:GetText()
							if mouseFrame.stext then
								cell.stext = mouseFrame.stext
								mouseFrame.stext = nil
							end
							mouseFrame.text:SetText("")
							mouseFrame.cname = nil
						end
					end
					function cell.Event.LeftUpoutside()
						mouseFrame:SetVisible(false)
						cell.text:SetText("")
						cell.back:SetBackgroundColor(0.5,0.5,0.5,1)
						cell.text:SetVisible(true)
						if cell.cname then
							cell.cname = nil
						end
						if cell.stext then
							cell.stext = nil
							mouseFrame.stext = nil
						end
						if cell.ltext then
							cell.ltext = nil
							mouseFrame.ltext = nil
						end
						if GS.cellConfig and GS.cellConfig:GetVisible() then
							GS.cellConfig:SetVisible(false)
						end
					end
					function cell.Event.RightClick()
						if cell.text:GetText() ~= "" then
							GS:PreviewCellConfig(cell)
						end
					end
			
				cell.back = UI.CreateFrame("Frame", name .. "_back", cell)
					cell.back:SetPoint("TOPLEFT", cell, "TOPLEFT", 2, 2)
					cell.back:SetPoint("BOTTOMRIGHT", cell, "BOTTOMRIGHT", -2, -2)
					cell.back:SetBackgroundColor(0.5,0.5,0.5,1)
					cell.back:SetVisible(true)
					cell.back:SetLayer(20)
		
				cell.text = UI.CreateFrame("Text", name .. "_text", cell.back)
					cell.text:SetPoint("CENTERLEFT", cell.back, "CENTERLEFT", 2, 0)
					cell.text:SetWidth(cell.back:GetWidth()-4)
					cell.text:SetFontColor(1,1,1,1)
					cell.text:SetFontSize(14)
					cell.text:SetVisible(false)
					cell.text:SetLayer(30)
			
				if pCol == 1 and pRow == 1 then
					cell:SetVisible(true)
				else
					cell:SetVisible(false)
				end
				previewLastRow = cell
			end
		end
		
	local reUpdate = false
	
	function previewUpdate(option, value)
	
		local posUp = math.floor(GS.preview.scrollbarUp:GetPosition())
		local posSide = math.floor(GS.preview.scrollbarSide:GetPosition())
		local ctext = GS.layout.Columns.value:GetText()
		local rtext = GS.layout.Rows.value:GetText()
		local upMin, upMax = GS.preview.scrollbarUp:GetRange()
		local sideMin, sideMax = GS.preview.scrollbarSide:GetRange()
		local nValue = toNum(value)
		
		
		if option == "row" and nValue < upMax+5 and not reUpdate then
			reUpdate = true
		elseif option == "column" and nValue < sideMax+2 and not reUpdate then
			reUpdate = true
		else
			reUpdate = false
		end
		
		if option == "row" and nValue > 5 then
			GS.preview.scrollbarUp:SetRange(1,math.abs(nValue-5))
		elseif option == "row" then
			GS.preview.scrollbarUp:SetRange(1,1)
		end
		
		if option == "column" and nValue > 2 then
			GS.preview.scrollbarSide:SetRange(1,math.abs(nValue-2))
		elseif option == "column" then
			GS.preview.scrollbarSide:SetRange(1,1)
		end
		
		function clearCell(cell)
			cell.text:SetText("")
			cell.back:SetBackgroundColor(0.5,0.5,0.5,1)
			cell.text:SetFontColor(1,1,1,1)
			cell.text:SetVisible(true)
			if cell.cname then
				cell.cname = nil
			end
			if cell.ltext then
				cell.ltext = nil
			end
			if GS.cellConfig and GS.cellConfig:GetVisible() then
				GS.cellConfig:SetVisible(false)
			end
		end
	
		for cell, data in pairs(GS.preview.view:GetChildren()) do
			if option == "row" and cell.row <= nValue and cell.column <= toNum(ctext) then
				if cell.row > posUp+5 then
					cell:SetVisible(false)
					if cell.row-5 > upMax then
						upMax = cell.row-5
					end
				elseif cell.row < posUp then
					cell:SetVisible(false)
				elseif cell.column > posSide+2 or cell.column < posSide then
					cell:SetVisible(false)
				else
					cell:SetVisible(true)
				end
				if not cell:GetVisible() and cell.row > nValue then
					clearCell(cell)
				end
			elseif option == "column" and cell.column <= nValue and cell.row <= toNum(rtext) then
				if cell.column > posSide+2 then
					cell:SetVisible(false)
					if cell.column-2 > sideMax then
						sideMax = cell.column-2
					end
				elseif cell.column < posSide then
					cell:SetVisible(false)
				elseif cell.row > posUp+5 or cell.row < posUp then
					cell:SetVisible(false)
				else
					cell:SetVisible(true)
				end
				if not cell:GetVisible() and cell.column > nValue then
					clearCell(cell)
				end
			else
				cell:SetVisible(false)
				if option == "row" and upMax > value-5 then
					if posUp > value-5 and value-5 > 0 then
						GS.preview.scrollbarUp:SetPosition(value-5)
					elseif value-5 <= 0 then
						GS.preview.scrollbarUp:SetPosition(1)
					end
				elseif option == "column" and sideMax > value-2 then
					if posSide > value-2 and value-2 > 0 then
						GS.preview.scrollbarSide:SetPosition(value-2)
					elseif value-2 <= 0 then
						GS.preview.scrollbarSide:SetPosition(1)
					end
				end
				if not cell:GetVisible() then
					if option == "row" and cell.row > nValue then
						clearCell(cell)
					elseif option == "column" and cell.column > nValue then
						clearCell(cell)
					end
				end
			end
		end
		if reUpdate then
			previewUpdate(option, value)
		end
	end
end

local function GetConfiguration()

	local configTable = {}
	
	for idx = 1, 10, 1 do
		table.insert(configTable, { {},{},{},{},{},{},{},{},{},{} } )
	end
	for cell, data in pairs(GS.preview.view:GetChildren()) do
		local bgr,bgg,bgb = cell.back:GetBackgroundColor()
		local bga = cell.alpha or 0.5
		local lblr,lblg,lblb = cell.text:GetFontColor()
		local statr,statg,statb
		if cell.statr and cell.statg and cell.statb then
			statr = cell.statr or 1
			statg = cell.statg or 1
			statb = cell.statb or 1
		else
			statr = 1
			statg = 1
			statb = 1
		end
		if cell.cname then
			if cell.stext then
				configTable[cell.column][cell.row] = { name = cell.cname, text = { text = cell.text:GetText(), stext = cell.stext, useStext = cell.useStext, ltext = cell.ltext }, Colors = { Back = {bgr,bgg,bgb,bga}, Label = {lblr,lblg,lblb}, Stat = {statr,statg,statb}} }
			else
				configTable[cell.column][cell.row] = { name = cell.cname, text = { text = cell.text:GetText(), ltext = cell.ltext }, Colors = { Back = {bgr,bgg,bgb,bga}, Label = {lblr,lblg,lblb}, Stat = {statr,statg,statb}} }
			end
		end
	end
	
	configTable.rowText = GS.layout.Rows.value:GetText()
	configTable.columnText = GS.layout.Columns.value:GetText()
	
	return configTable
	
end

local function SetConfiguration(config)

	Command.System.Watchdog.Quiet()

	GS.layout.Rows.value:SetText(config.rowText)
	previewUpdate("row", config.rowText)
	GS.layout.Columns.value:SetText(config.columnText)
	previewUpdate("column", config.columnText)

	for cell, data in pairs(GS.preview.view:GetChildren()) do
		if cell.row <= toNum(config.rowText) and cell.column <= toNum(config.columnText) then
			local cellData = config[cell.column][cell.row]
			if cellData.Colors then
				cell.back:SetBackgroundColor(cellData.Colors.Back[1],cellData.Colors.Back[2],cellData.Colors.Back[3],1)
				cell.text:SetFontColor(cellData.Colors.Label[1],cellData.Colors.Label[2],cellData.Colors.Label[3],1)
				cell.statr = cellData.Colors.Stat[1]
				cell.statg = cellData.Colors.Stat[2]
				cell.statb = cellData.Colors.Stat[3]
				cell.alpha = cellData.Colors.Back[4]
			end
			if cellData.name then
				if cellData.text.text then
					cell.text:SetText(cellData.text.text)
					cell.text:SetVisible(true)
					cell.ltext = cellData.text.ltext
					if cellData.text.stext then
						cell.stext = cellData.text.stext
						cell.useStext = cellData.text.useStext
					end
				else
					cell.text:SetText(cellData.text)
					cell.text:SetVisible(true)
					cell.ltext = cellData.text
				end
				cell.cname = cellData.name
			end
		end
	end
end

WT.Gadget.RegisterFactory("Stats",
	{
		name="Stats",
		description="Displays Player Stats",
		author="Noshei",
		version="1.2.0",
		iconTexAddon=AddonId,
		iconTexFile="img/stats_icon.png",
		["Create"] = Create,
		["ConfigDialog"] = ConfigDialog,
		["GetConfiguration"] = GetConfiguration, 
		["SetConfiguration"] = SetConfiguration, 
		["Reconfigure"] = Reconfigure,
	})
	
	
table.insert(Event.Mouse.Move,				{ mouseUpdate, AddonId, AddonId .. "_mouseFrame.Update" })
table.insert(Event.Stat,					{ statUpdate, AddonId, AddonId .. "_statUpdate" })